//Tasten
int tastenH = 50;
int anzahlT;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
char[] tBeschriftung;
PFont font;

//Parameter
double a,b,c,d,e,f;
//Bildausschnitt zu Beginn:

float G = 8.0;
float xU = -G/2; 
float yU = -G/2; 
float xO,yO;
float xK,yK;
float xHK,yHK;
float x,y;
int hgf = 0;//Hintergrund schwarz
boolean start=true;
boolean sP=false;//soll beim Mausklick gezoomt oder der Startpunkt eingetragen werden
color farbe;
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, sollte man mit double-Werten rechnen
double xStart = 0;
double yStart = 0;
int nPoints = 20000; // Punkte pro Orbit

// Hilfsvariablen
double xH = xStart;
double yH = yStart; 

///////////////////////////////////////////////////////////////////////////
//Initialisierungen  
///////////////////////////////////////////////////////////////////////////
void setup() { 
  size(800, 800);
  background(hgf);
  tastenEinstellungen();
  colorMode(HSB,256,256,256);
  stroke(0,255,255);
  strokeWeight(5);
  point(width/2.0,height/2.0);//Ursprung
  xO=xU+G; yO=yU+G;
  //Interessante Parameter:
  a = (double)random(-2.5,2.5); b = (double)random(-2.5,2.5); c =(double) random(-2.5,2.5); 
  d = (double)random(-2.5,2.5); e = (double)random(-4,4);     f = (double)random(1.001,2);

  //a = 2.1212635040283203;  b = -1.8915796279907227;  c = -1.2084922790527344;  d = 1.4489192962646484; e = -0.738502025604248 ; f = 1.656384825706482 ;
  a = -2.4914286136627197;  b = -1.0557746887207031;  c = -1.3139233589172363;  d = 2.4677958488464355; e = -0.6391472816467285 ; f = 1.6227550506591797 ;
  //a = -2.0734238624572754;  b = 0.7843055725097656;  c = 2.044926166534424;  d = 0.22103428840637207; e = 0.8174295425415039 ; f = 1.8590664863586426 ;


  println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";"+" e = "+e+" ;"+" f = "+f+" ;");
  println(xU,xO,yU,yO); 
}
///////////////////////////////////////////////////////////////////////////
void draw() {
  tastenZeichnen();
  if(start){    
    if(!sP) background(hgf);
    iteriere(xH,yH); 
  
  
    start = false;
  }
}
///////////////////////////////////////////////
void tastenEinstellungen(){
   rectMode(CENTER);
   font = createFont("Arial",20);
   textSize(24);  
   String s = "nhpzs";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false; 
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
//////////////////////////////////////

void keyPressed() {  //für Tastaturbedienung
  if (key == 'n') {
     nPoints = 2*nPoints;
     start = true;
  }  
  if (key == 'h'){
    if(hgf==0) hgf=255;
    else hgf = 0;
    background(hgf);
    start = true;
  }
  if(key == 'p'){
    sP = !sP;
  }
  if(key == 'z'){
    sP=false;
    a = (double)random(-2.5,2.5); b = (double)random(-2.5,2.5); c =(double) random(-2.5,2.5); 
    d = (double)random(-2.5,2.5); e = (double)random(-4,4);     f = (double)random(1.001,2);
    println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";"+" e = "+e+" ;"+" f = "+f+" ;");
  
    start = true;
  }
  if (key == 's') save("CA1.jpg");
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird vergrößert bzw der neue Startpunkt eingetragen
//////////////////////////////////////////////////////

void mousePressed() {  
   if(mouseY < height-tastenH){
    x = xU + G*mouseX/width;
    y = yU + G*(height-mouseY)/height;  
    if (!sP){
      background(hgf);
      G*=0.66;
      xU = x-G/2.0;xO = xU+G;
      yU = y-G/2.0;yO = yU+G;
      println(x,y,xU,yU,xO,yO);
    }
    if( sP){
      strokeWeight(5);
      farbe = color(random(255),255,255);
      stroke(farbe);
      point(mouseX,mouseY);
      xH = x;
      yH = y;
      println("Neuer Startpunkt: "+xH,yH);
      iteriere(xH,yH); 
    }
    start = true;
   }else{
      int ort = int(mouseX/(tastenH));
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
      switch(ort){
        
      case 0://'n'   
         tasteAktiv[0]=true;
         nPoints = 2*nPoints;
         start = true;
      break;
      
      case 1: //'h'   
       tasteAktiv[1]=true;
       if(hgf==0) hgf=255;
        else hgf = 0;
       background(hgf);
       start = true;
      break;
      
      case 2://'p'
       tasteAktiv[2]=true;
       sP = !sP;
      break;
      
      case 3: //'z'   
       tasteAktiv[3]=true;
       sP=false;
     a = (double)random(-2.5,2.5); b = (double)random(-2.5,2.5); c =(double) random(-2.5,2.5); 
     d = (double)random(-2.5,2.5); e = (double)random(-4,4);     f = (double)random(1.001,2);
       println("a = "+a+";  b = "+b+";  c = "+c+";  d = "+d+";"+" e = "+e+" ;"+" f = "+f+" ;");
       start = true;
      break;
      
      case 4://'s'   Online Version ohne save
       tasteAktiv[4]=true;
       a=-1.4; b=1.6;c=1.0;d=0.7;
       println(xU,xO,yU,yO);
       nPoints = 20000;
       sP=false;
       G = 6.0;
       xU = -3.0; xO = xU+G;
       yU = -3.0; yO = yU+G;
       start = true;       
      break;
      
      default:      
        println("Keine Aktion");
      break;
  }
 }
}
//////////////////////////////////////////////////////////
void iteriere(double xAlt,double yAlt) {  
   double x = xAlt;
   double y = yAlt;
  if(!sP){
      farbe = color(random(255),255,255);
      stroke(farbe); 
  }
  int i=0;
  strokeWeight(1);
  
  while (i <=nPoints) {
    if (Math.abs(xAlt)< 100 && Math.abs(yAlt)< 100) {
       double xt = x;
       double yt = y;
       x = Math.sin(a*yt) + c*Math.cos(a*xt) + e*Math.cos(a*xt)/(Math.sin(a*xt)+f);
       y = Math.cos(b*xt) + d*Math.sin(b*yt) + e*Math.sin(b*yt)/(Math.cos(b*yt)+f);
       float xK = round(map((float)x, xU, xO, 0, width));                 
       float yK = round(map((float)y, yU, yO, 0, height));    
       point(xK, height-yK);  
    }
    i++;
  }
  println(nPoints+" Punkte eingetragen");
}
////////////////////////////////////////////////////////
void tastenZeichnen(){
  tastenWechsel=true;
  fill(160,180,180);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(40,255,255));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);     
  }   
}
